//version 1.3.1 updated on 07/09/2000

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class Chess extends Applet 
{
	Frame		frame;
	MenuBar		menuBar;
	Menu		fileMenu, subMenu, helpMenu;
	MenuItem	newGame, closeGame, subThis, subThat, helpGame, aboutGame;
	CheckboxMenuItem	option1;
	Button		resetButton, undoButton;
	AskNameDialog		d;
	AboutDialog			aboutDialog;

	ChessBoard game;

	public void init()
	{  

		frame = new Frame("5_piece Chinese Chess Game");
		frame.setSize(750, 700);
		
		game = new ChessBoard();
		
		Button btn = new Button("Click me to play the game");
		ButtonListener btnl = new ButtonListener();
		btn.addActionListener(btnl);
		add(btn);
	}

	public void showFrame()
	{
		frame = new Frame("5_piece Chinese Chess Game");
		frame.setSize(750, 700);

		
		fileMenu = new Menu("File");
		newGame = new MenuItem("New Game");
		closeGame = new MenuItem("Close");

		subMenu = new Menu("Sub Menu");
		subThis = new MenuItem("SubThis");
		subThat = new MenuItem("SubThat");

		option1 = new CheckboxMenuItem("one Option");
		menuBar = new MenuBar();
		frame.setMenuBar(menuBar);

		fileMenu.add(newGame);
		fileMenu.add(closeGame);
		fileMenu.addSeparator();
		fileMenu.add(option1);

		subMenu.add(subThis);
		subMenu.add(subThat);
		fileMenu.add(subMenu);
		menuBar.add(fileMenu);

		helpMenu = new Menu("Help");
		helpGame = new MenuItem("Help");
		aboutGame = new MenuItem("About");
		helpMenu.add(helpGame);
		helpMenu.add(aboutGame);
		menuBar.setHelpMenu(helpMenu);

		frame.setVisible(true);

		CloseListener closelistener = new CloseListener();
		closeGame.addActionListener(closelistener);
	
		AboutListener aboutlistener = new AboutListener();
		aboutGame.addActionListener(aboutlistener);

        frame.addWindowListener(new WindowAdapter()
		{
            public void windowClosing(WindowEvent e) 
			{
               e.getWindow().dispose();
			   game.reset();
             }
         }
        );

		Panel p;
  
		resetButton = new Button("Reset");
		undoButton = new Button("Undo one step");
		
		p = new Panel();
		p.setLayout(new BorderLayout());
		p.add("Center",game);
		Panel p1 = new Panel();
		p1.setLayout(new BorderLayout());
		Panel p2 = new Panel();
		p2.setLayout(new GridLayout(2,1, 10, 20));
		p2.add(resetButton);
		p2.add(undoButton);
		p1.add("North",p2);
		p.add("East",p1);
		frame.add(p);

		ResetListener resetListener = new ResetListener();
		resetButton.addActionListener(resetListener);
			
		UndoListener undoListener = new UndoListener();
		undoButton.addActionListener(undoListener);

		NewGameListener ngListener = new NewGameListener();
		newGame.addActionListener(ngListener);
  
		game.draw();
	};
	

	class ButtonListener implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			d = new AskNameDialog(frame, "Enter players' names", true);
			d.setVisible(true);
			
			game.setPlayer1Name(d.getPlayer1Name());
			game.setPlayer2Name(d.getPlayer2Name());
			//System.out.println(d.getPlayer1Name());
			showFrame();
			//System.out.println(d.getPlayer1Name());
		}
	};

	class CloseListener implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			game.reset();
			frame.setVisible(false);
			frame.dispose();
		}
	};

	class AboutListener implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			aboutDialog = new AboutDialog(frame, "About", true);
			aboutDialog.setVisible(true);
		}
	};
	
	class ResetListener implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			game.reset();
		}
	};
	
	class UndoListener implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			game.undo();
		}
	};

	class NewGameListener implements ActionListener
	{
		public void actionPerformed(ActionEvent ae)
		{
			game.reset();
		}
	};
}



